#include "StdAfx.h"
#include "CurrentChatBuddyController.h"

CCurrentChatBuddyController::CCurrentChatBuddyController(void)
{
	m_vecCurrentBuddy.clear();
}

CCurrentChatBuddyController::~CCurrentChatBuddyController(void)
{
}

void CCurrentChatBuddyController::LoadIniFile()
{

	TCHAR buf[2048]={NULL,};
	GetPrivateProfileString(_T("ClientConfig"),_T("CurrentChatBuddy"),_T(""),
		buf,2048,GET_CONFIG()->GetClientConfigPath());
	m_strCurrentBuddyList = (LPCTSTR)buf;
}

void CCurrentChatBuddyController::SaveIniFile()
{
	m_strCurrentBuddyList = _T("");
	vector<CString>::iterator itr = m_vecCurrentBuddy.begin();
	for(;itr != m_vecCurrentBuddy.end(); itr++)
	{
		CString strID = *itr;
		m_strCurrentBuddyList.AppendFormat(_T("%s;"), strID);
	}


		WritePrivateProfileString(_T("ClientConfig"), _T("CurrentChatBuddy"), m_strCurrentBuddyList, GET_CONFIG()->GetClientConfigPath());

}

void CCurrentChatBuddyController::LoadCurrentBuddy()
{
	LoadIniFile();
	CString strSubText;
	int i=0;
	while(1)
	{
		if( !AfxExtractSubString(strSubText, m_strCurrentBuddyList, i++, ';') )
			break;
		if (strSubText==L"" || m_vecCurrentBuddy.size() > 10)
			break;
		if (!IsDuplication(strSubText))
			m_vecCurrentBuddy.push_back(strSubText);
	}
}

void CCurrentChatBuddyController::SetCurrentChatBuddy(LPCTSTR strID)
{
	if (IsDuplication(strID))
	{
		vector<CString>::const_iterator itr = find(m_vecCurrentBuddy.begin(), m_vecCurrentBuddy.end() , strID);
		m_vecCurrentBuddy.erase(itr);
	}
	else if(m_vecCurrentBuddy.size() > 10)
	{
		vector<CString>::const_iterator itr = m_vecCurrentBuddy.end();
		m_vecCurrentBuddy.erase(itr);
	}
	else
	{
	}
	vector<CString>::iterator itrInsertPos = m_vecCurrentBuddy.begin();
	m_vecCurrentBuddy.insert(itrInsertPos, strID );
	SaveIniFile();

}

BOOL CCurrentChatBuddyController::IsDuplication(CString strCheckID)
{
	BOOL bRet = FALSE;
	vector<CString>::const_iterator itr = find(m_vecCurrentBuddy.begin(), m_vecCurrentBuddy.end() , strCheckID);
	if (itr != m_vecCurrentBuddy.end())
		bRet = TRUE;

	return bRet;
}
